Subject: Re: "atomic" 64-bit math on 32-bit ppc's?

From: Gabriel Paubert <[email-masked]>
Date: Tue, 4 Sep 2007 18:02:06 +0200

On Tue, Sep 04, 2007 at 01:31:07PM +0100, Matt Sealey wrote:
> 
> Gabriel Paubert wrote:
> >On Tue, Sep 04, 2007 at 12:09:22PM +0100, Matt Sealey wrote:
> >>Hi guys,
> >>
> >>The Solaris PPC code drop included most of these functions for 32-bit ops 
> >>on
> >>32-bit PPC architectures but the 64-bit operations are not present. What I
> >>a not clear on is the operation of lwarx and stwcx. and if they will work 
> >>if
> >>you are doing operations on two words at a time.
> >
> >No. There is a single reservation for a single word.
> 
> This is what I gathered from the programming environments manual at least.

Well, that's because it is fundamentally impossible to 
have more than one, what would the hardware do if the second
update fails after the first has succeeded?

> 
> >the 64 bit operations inside a spinlock on PPC32, and then select the
> >number /location of spinlock(s) based on your needs, from one global
> >per machine to one per 64 bit variable if you find excessive contention.
> 
> Okay that makes sense, but it would have to be a super global big lock,
> I don't think the code is there in ZFS to give every 64-bit variable it's
> own dedicated spinlock (kind of an overhaul) and I'm trying to be fast..

I don't know at all the ZFS code, not any filesystem code for the
matter. But how many spinlocks would you have to take and release 
per actual disk operation?

	Regards,
	Gabriel